>From 3c5d1046cc5c4e5821053da1610d028dba6c467b Mon Sep 17 00:00:00 2001
From: Adam Young <ayoung@redhat.com>
Date: Wed, 7 Dec 2011 21:06:29 -0500
Subject: [PATCH] Indent in conditionals

Additional Formatting generated by Eclipse  3.7.1
It provides more detailed control of the indentation which is not provided in the earlier version
---
 pki/base/ca/src/com/netscape/ca/CAService.java     |    2 +-
 .../ca/src/com/netscape/ca/CRLIssuingPoint.java    |    6 +++---
 .../netscape/certsrv/request/ARequestNotifier.java |    2 +-
 .../cms/crl/CMSHoldInstructionExtension.java       |    2 +-
 .../netscape/cms/profile/common/BasicProfile.java  |    2 +-
 .../src/com/netscape/cms/servlet/cert/GetCRL.java  |    6 +++---
 .../cms/servlet/cert/scep/CRSEnrollment.java       |    2 +-
 7 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/pki/base/ca/src/com/netscape/ca/CAService.java b/pki/base/ca/src/com/netscape/ca/CAService.java
index 44ab65bcf7cf42263ca84eb0af8dc25ba20de749..2c03f89d4f3129d290da696ad9b5ab6a519c18dc 100644
--- a/pki/base/ca/src/com/netscape/ca/CAService.java
+++ b/pki/base/ca/src/com/netscape/ca/CAService.java
@@ -489,7 +489,7 @@ public class CAService implements ICAService, IService {
 
         if (!(type.equals(IRequest.REVOCATION_REQUEST)
                 || type.equals(IRequest.UNREVOCATION_REQUEST) || type
-                .equals(IRequest.CMCREVOKE_REQUEST))) {
+                    .equals(IRequest.CMCREVOKE_REQUEST))) {
             // store a message in the signed audit log file
             auditMessage = CMS.getLogMessage(
                     LOGGING_SIGNED_AUDIT_PRIVATE_KEY_ARCHIVE_REQUEST,
diff --git a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
index 064832fe4acb26b93c218ca07b267874e699d49c..5ee163d9b45fe7d125e8b23f054ce243a666acea 100644
--- a/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
+++ b/pki/base/ca/src/com/netscape/ca/CRLIssuingPoint.java
@@ -2355,7 +2355,7 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
                         .isCRLExtensionEnabled(DeltaCRLIndicatorExtension.NAME)
                 && mCMSCRLExtensions
                         .isCRLExtensionEnabled(CRLNumberExtension.NAME) && mCMSCRLExtensions
-                .isCRLExtensionEnabled(CRLReasonExtension.NAME));
+                    .isCRLExtensionEnabled(CRLReasonExtension.NAME));
     }
 
     public boolean isThisCurrentDeltaCRL(X509CRLImpl deltaCRL) {
@@ -2544,7 +2544,7 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
                 || ((mCRLCacheIsCleared && mCRLCerts.isEmpty()
                         && clonedRevokedCerts.isEmpty()
                         && clonedUnrevokedCerts.isEmpty() && clonedExpiredCerts
-                        .isEmpty())
+                            .isEmpty())
                         || (mCRLCerts.isEmpty() && (!clonedUnrevokedCerts
                                 .isEmpty()))
                         || (mCRLCerts.size() < clonedUnrevokedCerts.size())
@@ -2716,7 +2716,7 @@ public class CRLIssuingPoint implements ICRLIssuingPoint, Runnable {
             if (mSchemaCounter == 0) {
                 if (((!mCRLCerts.isEmpty()) && ((!clonedRevokedCerts.isEmpty())
                         || (!clonedUnrevokedCerts.isEmpty()) || (!clonedExpiredCerts
-                        .isEmpty())))
+                            .isEmpty())))
                         || (mCRLCerts.isEmpty() && (mCRLSize == 0) && (!clonedRevokedCerts
                                 .isEmpty()))) {
 
diff --git a/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java b/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java
index 62977c9b76426bc67e454e1a90c4aaad2b87c027..e17ba42c4814b6f30f304111b37f884b67ac794e 100644
--- a/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java
+++ b/pki/base/common/src/com/netscape/certsrv/request/ARequestNotifier.java
@@ -238,7 +238,7 @@ public class ARequestNotifier implements IRequestNotifier {
                             || requestType.equals(IRequest.RENEWAL_REQUEST)
                             || requestType.equals(IRequest.REVOCATION_REQUEST)
                             || requestType.equals(IRequest.CMCREVOKE_REQUEST) || requestType
-                            .equals(IRequest.UNREVOCATION_REQUEST))) {
+                                .equals(IRequest.UNREVOCATION_REQUEST))) {
                         continue;
                     }
                     if (i == 0 && id.equals(r.getRequestId().toString())) {
diff --git a/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java b/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java
index 4d76625d1db98226a29f0a0953eba74cbcc4d51f..1eff1534787c6a391e5e68931f27553537cc2c57 100644
--- a/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java
+++ b/pki/base/common/src/com/netscape/cms/crl/CMSHoldInstructionExtension.java
@@ -124,7 +124,7 @@ public class CMSHoldInstructionExtension implements ICMSCRLExtension,
         if (instruction != null) {
             if (!(instruction.equalsIgnoreCase(PROP_INSTR_NONE)
                     || instruction.equalsIgnoreCase(PROP_INSTR_CALLISSUER) || instruction
-                    .equalsIgnoreCase(PROP_INSTR_REJECT))) {
+                        .equalsIgnoreCase(PROP_INSTR_REJECT))) {
                 instruction = PROP_INSTR_NONE;
             }
         } else {
diff --git a/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java b/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
index 57832486978c1a74b67808d66925e773762572e3..96a8a192da64423bbd5b50320d876ba02ec6f1ab 100644
--- a/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
+++ b/pki/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
@@ -882,7 +882,7 @@ public abstract class BasicProfile implements IProfile {
 
                 if ((curDefaultClassId.equals(defaultClassId)
                         && !curDefaultClassId.equals(PROP_NO_DEFAULT) && !curDefaultClassId
-                        .equals(PROP_GENERIC_EXT_DEFAULT))) {
+                            .equals(PROP_GENERIC_EXT_DEFAULT))) {
 
                     matches++;
                     if (createConfig) {
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/GetCRL.java b/pki/base/common/src/com/netscape/cms/servlet/cert/GetCRL.java
index 3b87ed5a5acb56c8672bc07a1040de4603fff94f..f32b4484b648ee9e9aa2774be700b45295d027bf 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/GetCRL.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/GetCRL.java
@@ -228,7 +228,7 @@ public class GetCRL extends CMSServlet {
                 || (op.equals("displayCRL") && crlDisplayType != null && (crlDisplayType
                         .equals("entireCRL")
                         || crlDisplayType.equals("crlHeader") || crlDisplayType
-                        .equals("base64Encoded")))) {
+                            .equals("base64Encoded")))) {
             crlbytes = crlRecord.getCRL();
         }
 
@@ -254,7 +254,7 @@ public class GetCRL extends CMSServlet {
                         .equals("entireCRL")
                         || crlDisplayType.equals("crlHeader")
                         || crlDisplayType.equals("base64Encoded") || crlDisplayType
-                        .equals("deltaCRL")))) {
+                            .equals("deltaCRL")))) {
             try {
                 if (op.equals("displayCRL") && crlDisplayType != null
                         && crlDisplayType.equals("crlHeader")) {
@@ -273,7 +273,7 @@ public class GetCRL extends CMSServlet {
             }
             if ((op.equals("importDeltaCRL") || (op.equals("displayCRL")
                     && crlDisplayType != null && crlDisplayType
-                    .equals("deltaCRL")))
+                        .equals("deltaCRL")))
                     && ((!(crlIP != null && crlIP.isThisCurrentDeltaCRL(crl))) && (crlRecord
                             .getCRLNumber() == null
                             || crlRecord.getDeltaCRLNumber() == null
diff --git a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java
index fe2485a60f71e4f4d55af11b5f546e4a8c49eeed..49ab9cc6efa529369963d7686bc13ecda49de1c2 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/cert/scep/CRSEnrollment.java
@@ -257,7 +257,7 @@ public class CRSEnrollment extends HttpServlet {
                 if (!(mTokenName.equalsIgnoreCase(Constants.PR_INTERNAL_TOKEN)
                         || mTokenName
                                 .equalsIgnoreCase("Internal Key Storage Token") || mTokenName
-                        .length() == 0)) {
+                            .length() == 0)) {
                     int i = mNickname.indexOf(':');
                     if (!((i > -1) && (mTokenName.length() == i) && (mNickname
                             .startsWith(mTokenName)))) {
-- 
1.7.7.3